/**
  Watch out for memory leaks with upcasting!
  The behavior of the destructor mimics that of overridden functions
 **/

#include <iostream>
using std::cout;
using std::endl;

class Base
{
    public:
        virtual ~Base()
        {
            cout << "Base Destructor" << endl;
        }
};

class Derived: public Base
{
    public:
        ~Derived()
        {
            cout<< "Derived Destructor" << endl;
        }
};

int main()
{
    Base* b = new Derived;     //Upcasting

    // Which destructor(s) get called here?
    // Pointer of a base type pointing to a derived object
    delete b;

    return 0;
}
